diff --git a/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java b/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java
new file mode 100644
index 000000000..a679a2b34
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java
@@ -0,0 +1,94 @@
+package net.minecraft.client.render.texture.meta;
+
+import com.b100.utils.StringUtils;
+import com.google.gson.Gson;
+import com.google.gson.GsonBuilder;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonParser;
+import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
+import net.minecraft.client.render.texture.meta.gui.GuiTexturePropertiesAdapter;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.io.InputStream;
+import java.util.HashMap;
+import java.util.Map;
+
+public class TextureMetaHandler {
+    private static final Gson GSON;
+    static {
+        GsonBuilder builder = new GsonBuilder();
+        builder.setPrettyPrinting();
+        builder.registerTypeAdapter(TextureProperties.class, new TexturePropertiesAdapter());
+        builder.registerTypeAdapter(AnimationProperties.class, new AnimationPropertiesAdapter());
+        builder.registerTypeAdapter(GuiTextureProperties.class, new GuiTexturePropertiesAdapter());
+        GSON = builder.create();
+    }
+    @Nullable
+    private JsonObject metaJson = null;
+    @NotNull
+    private final Map<String, Object> cachedData = new HashMap<>();
+
+    public void reset() {
+        metaJson = null;
+        cachedData.clear();
+    }
+
+    public void loadFromStream(InputStream stream) {
+        String jsonString;
+        try {
+            jsonString = StringUtils.readInputString(stream);
+        } catch (Exception e) {
+            e.printStackTrace();
+            return;
+        }
+        try {
+            metaJson = JsonParser.parseString(jsonString).getAsJsonObject();
+        } catch (JsonParseException e) { // TODO, replace with proper non-fatal error logging
+            e.printStackTrace();
+        }
+    }
+
+    public boolean has(String key) {
+        return cachedData.containsKey(key) || (metaJson != null && metaJson.has(key));
+    }
+
+    @SuppressWarnings("unchecked") // I'm literally checking
+    public @Nullable <T> T get(String key, Class<T> aClass) {
+        if (cachedData.containsKey(key)) {
+            Object o = cachedData.get(key);
+            if (o.getClass().isAssignableFrom(aClass)) {
+                return (T) cachedData.get(key);
+            }
+        }
+        if (metaJson != null && metaJson.has(key)) {
+            T obj = GSON.fromJson(metaJson.get(key), aClass);
+            cachedData.put(key, obj);
+            return obj;
+        }
+        return null;
+    }
+
+    @SuppressWarnings("unchecked") // I'm literally checking
+    public <T> T getOrDefault(String key, T metaDefault, Class<T> aClass) {
+        if (cachedData.containsKey(key)) {
+            Object o = cachedData.get(key);
+            if (o.getClass().isAssignableFrom(aClass)) {
+                return (T) cachedData.get(key);
+            }
+        }
+        if (metaJson != null && metaJson.has(key)) {
+            T obj = GSON.fromJson(metaJson.get(key), aClass);
+            cachedData.put(key, obj);
+            return obj;
+        }
+        return metaDefault;
+    }
+
+    @Override
+    public String toString(){
+        if (metaJson == null) return null;
+        return GSON.toJson(metaJson);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/TextureProperties.java b/src/main/java/net/minecraft/client/render/texture/meta/TextureProperties.java
new file mode 100644
index 000000000..aa20211c4
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/TextureProperties.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.texture.meta;
+
+public class TextureProperties {
+    public final boolean blur;
+    public final boolean clamp;
+    public final boolean mipmap;
+    public TextureProperties(Boolean blur, Boolean clamp, Boolean mipmap) {
+        if (blur == null) {
+            this.blur = false;
+        } else {
+            this.blur = blur;
+        }
+
+        if (clamp == null) {
+            this.clamp = false;
+        } else {
+            this.clamp = clamp;
+        }
+
+        if (mipmap == null) {
+            this.mipmap = false;
+        } else {
+            this.mipmap = mipmap;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/TexturePropertiesAdapter.java b/src/main/java/net/minecraft/client/render/texture/meta/TexturePropertiesAdapter.java
new file mode 100644
index 000000000..68a6ba04a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/TexturePropertiesAdapter.java
@@ -0,0 +1,40 @@
+package net.minecraft.client.render.texture.meta;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+
+import java.lang.reflect.Type;
+
+public class TexturePropertiesAdapter implements JsonDeserializer<TextureProperties>, JsonSerializer<TextureProperties> {
+    @Override
+    public TextureProperties deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject jObject = json.getAsJsonObject();
+        Boolean blur = null;
+        Boolean clamp = null;
+        Boolean mip = null;
+        if (jObject.has("blur")) {
+            blur = jObject.get("blur").getAsBoolean();
+        }
+        if (jObject.has("clamp")) {
+            clamp = jObject.get("clamp").getAsBoolean();
+        }
+        if (jObject.has("mipmaps")) {
+            mip = jObject.get("mipmaps").getAsBoolean();
+        }
+        return new TextureProperties(blur, clamp, mip);
+    }
+
+    @Override
+    public JsonElement serialize(TextureProperties src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject obj = new JsonObject();
+        obj.addProperty("blur",     src.blur);
+        obj.addProperty("clamp",    src.clamp);
+        obj.addProperty("mipmaps",  src.mipmap);
+        return obj;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
new file mode 100644
index 000000000..9cf491e4d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.texture.meta.gui;
+
+public class GuiTextureProperties {
+    public static final String TYPE_STRETCH = "stretch";
+    public static final String TYPE_TILE = "tile";
+    public static final String TYPE_NINE_SLICE = "nine_slice";
+
+    public final String type;
+    public final int width;
+    public final int height;
+    public final Border border;
+
+    public GuiTextureProperties(String type, int width, int height, Border border) {
+        this.type = type;
+        this.width = width;
+        this.height = height;
+        this.border = border;
+    }
+
+    public static class Border {
+        public final int left;
+        public final int top;
+        public final int right;
+        public final int bottom;
+
+        public Border(int size) {
+            left = top = right = bottom = size;
+        }
+
+        public Border(int left, int top, int right, int bottom) {
+            this.left = left;
+            this.top = top;
+            this.right = right;
+            this.bottom = bottom;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java
new file mode 100644
index 000000000..08c7e3292
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTexturePropertiesAdapter.java
@@ -0,0 +1,62 @@
+package net.minecraft.client.render.texture.meta.gui;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+
+import java.lang.reflect.Type;
+
+public class GuiTexturePropertiesAdapter implements JsonDeserializer<GuiTextureProperties>, JsonSerializer<GuiTextureProperties> {
+    @Override
+    public GuiTextureProperties deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject jo = json.getAsJsonObject();
+        String type = GuiTextureProperties.TYPE_STRETCH;
+        int width = jo.get("width").getAsInt();
+        int height = jo.get("height").getAsInt();
+        GuiTextureProperties.Border border = new GuiTextureProperties.Border(0);
+
+        if (jo.has("type")) {
+            type = jo.get("type").getAsString();
+        }
+
+        if (jo.has("border")) {
+            JsonElement be = jo.get("border");
+            if (be.isJsonPrimitive()) {
+                border = new GuiTextureProperties.Border(be.getAsInt());
+            } else if (be.isJsonObject()) {
+                JsonObject borderObj = be.getAsJsonObject();
+                border = new GuiTextureProperties.Border(
+                    borderObj.get("left").getAsInt(),
+                    borderObj.get("top").getAsInt(),
+                    borderObj.get("right").getAsInt(),
+                    borderObj.get("bottom").getAsInt());
+            }
+        }
+
+        return new GuiTextureProperties(type, width, height, border);
+    }
+
+    @Override
+    public JsonElement serialize(GuiTextureProperties src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject element = new JsonObject();
+        element.addProperty("type", src.type);
+        element.addProperty("width", src.width);
+        element.addProperty("height", src.height);
+        if (src.border.left == src.border.right && src.border.left == src.border.top && src.border.left == src.border.bottom) {
+            element.addProperty("border", src.border.left);
+        } else {
+            JsonObject border = new JsonObject();
+            border.addProperty("left", src.border.left);
+            border.addProperty("top", src.border.top);
+            border.addProperty("right", src.border.right);
+            border.addProperty("bottom", src.border.bottom);
+            element.add("border", border);
+        }
+
+        return element;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java b/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
similarity index 51%
rename from src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
rename to src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index 6b6d901a9..681dc91be 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -1,30 +1,33 @@
-package net.minecraft.client.render.stitcher;
+package net.minecraft.client.render.texture.stitcher;
 
 import java.awt.AlphaComposite;
 import java.awt.Graphics2D;
 import java.awt.image.BufferedImage;
+import java.io.InputStream;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.HashMap;
-import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
+import java.util.concurrent.Callable;
+import java.util.concurrent.ExecutionException;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.Executors;
+import java.util.concurrent.Future;
 
-import net.minecraft.core.Global;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import net.minecraft.client.GLAllocation;
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.customatlas.CustomAtlasHandler;
 import net.minecraft.client.util.helper.Textures;
 
-public class AtlasStitcher {
-    private static final Minecraft mc = Minecraft.getMinecraft(AtlasStitcher.class);
+public class AtlasStitcher extends Texture {
     public static final String rootAssetPath = "/assets";
     public Map<NamespaceID, IconCoordinate> textureMap = new HashMap<>();
-    public Set<IconCoordinate> dontSetSize = new HashSet<>();
     public BufferedImage atlas;
     public final String directoryPath;
     @Nullable
@@ -33,11 +36,11 @@ public class AtlasStitcher {
     private int atlasHeight;
     private double invWidth;
     private double invHeight;
-    private final int textureId;
     private final boolean mipmap;
-    public AtlasStitcher(String directoryPath, boolean mipmap, @Nullable String defaultTexture){
+    private final boolean tickPaused;
+    public AtlasStitcher(String directoryPath, boolean tickWhenPaused, boolean mipmap, @Nullable String defaultTexture){
         this.directoryPath = directoryPath;
-        this.textureId = Global.isServer ? -1 : GLAllocation.generateTexture();
+        this.tickPaused = tickWhenPaused;
         this.mipmap = mipmap;
         this.defaultTexture = defaultTexture;
     }
@@ -52,31 +55,44 @@ public class AtlasStitcher {
     public String getSourceImagePath(@NotNull NamespaceID id){
         return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace, directoryPath, id.value);
     }
-    public void generateAtlas(){
+
+    public void preinit() {
+        generate();
+        long startTime = System.nanoTime();
+        Minecraft mc = Minecraft.getMinecraft(this);
+        List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
+        List<Future<?>> futures = new ArrayList<>();
+        ExecutorService service = Executors.newFixedThreadPool(32);
+        for (IconCoordinate coordinate : coordinateList){
+            futures.add(service.submit(new SetupTexture(mc, coordinate, defaultTexture)));
+        }
+        for (Future<?> f : futures) {
+            try {
+                f.get();
+            } catch (InterruptedException | ExecutionException e) {
+                e.printStackTrace();
+            }
+        }
+        service.shutdown();
+        System.out.println("Took '" + (System.nanoTime() - startTime)/1_000_000_000d + "' seconds to load images.");
+    }
+
+    @Override
+    public void init(){
         // Load all individual textures and the store the widths
         int area = 0;
         int maxWidth = 0;
         List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
         for (IconCoordinate coordinate : coordinateList){
-        	if(dontSetSize.contains(coordinate)) {
-        		continue;
-        	}
-            BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(coordinate.sourceImage));
-            if (image == null || image == Textures.missingTexture){
-                System.out.println(coordinate.sourceImage + " could not be found!");
-                if (defaultTexture != null){
-                    image = Textures.readImage(mc.texturePackList.getResourceAsStream(defaultTexture));
-                }
-                if (image == null) image = Textures.missingTexture; // If this ever happens I'll be very sad
+            if (coordinate.needsDimensions()) {
+                BufferedImage image = coordinate.getImageStorage();
+                coordinate.setDimension(image.getWidth(), image.getHeight());
             }
-            coordinate.setImage(image);
-            coordinate.setDimension(image.getWidth(), image.getHeight());
             area += coordinate.getArea();
             if (coordinate.width > maxWidth) maxWidth = coordinate.width;
         }
-        dontSetSize.clear();
         // Calculate an okay atlas width to keep the aspect ratio of the final atlas mostly 1:1
-        int targetWidth = (int) (Math.max(Math.ceil(Math.sqrt(area)), maxWidth));
+        int targetWidth = Integer.highestOneBit((int) Math.max(Math.ceil(Math.sqrt(area)), maxWidth)) << 1;
         Collections.sort(coordinateList);
 
         // Find positions for each texture on the atlas
@@ -95,11 +111,8 @@ public class AtlasStitcher {
             if (nextX > maxRealWidth) maxRealWidth = nextX;
         }
 
-        // Needs to be square or mipmaps die
-        int length = Math.max(maxRealWidth, nextY);
-
         // Generate and then copy the data to a new image with the dimensions needed
-        BufferedImage generatedAtlas = new BufferedImage(length, length, BufferedImage.TYPE_INT_ARGB);
+        BufferedImage generatedAtlas = new BufferedImage(targetWidth, Integer.highestOneBit(nextY) << 1, BufferedImage.TYPE_INT_ARGB);
         Graphics2D atlas = generatedAtlas.createGraphics();
         atlas.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f));
         for (IconCoordinate coordinate : coordinateList){
@@ -114,21 +127,9 @@ public class AtlasStitcher {
         invHeight = 1d/atlasHeight;
         this.atlas = generatedAtlas;
 
-//        File folder = new File(Global.accessor.getMinecraftDir(), "testDumps");
-//        folder.mkdirs();
-//        Textures.saveImage(new File(folder, "atlasTest.png"), generatedAtlas);
-//        for (IconCoordinate c : coordinateList){
-//            System.out.println(c);
-//        }
-
-        mc.renderEngine.setupTexture(this.atlas, textureId, mipmap);
-    }
-    public void bindTexture(){
-        mc.renderEngine.bindTexture(textureId);
-    }
-    public int getTextureId(){
-        return textureId;
+        setupTexture(this.atlas, false, false, mipmap);
     }
+
     public int getAtlasWidth(){
         return atlasWidth;
     }
@@ -141,4 +142,46 @@ public class AtlasStitcher {
     public double getInverseHeight(){
         return invHeight;
     }
+    public boolean tickWhenPaused() {return tickPaused;}
+    public boolean hasMipmaps() {return mipmap;}
+
+    public static class SetupTexture implements Callable<IconCoordinate> {
+        private final Minecraft mc;
+        private final IconCoordinate coordinate;
+        private final String defaultTexture;
+        public SetupTexture(Minecraft mc, IconCoordinate coordinate, String defaultTexture) {
+            this.mc = mc;
+            this.coordinate = coordinate;
+            this.defaultTexture = defaultTexture;
+        }
+        @Override
+        public IconCoordinate call() throws Exception {
+            coordinate.resetMetadata();
+            BufferedImage image = CustomAtlasHandler.getTextureOverride(mc.texturePackList, coordinate.sourceImage);
+            if(image == null) {
+                TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(coordinate.sourceImage);
+                if (pack != null) {
+                    image = Textures.readImage(pack.getResourceAsStream(coordinate.sourceImage));
+                    String metaPath = coordinate.sourceImage + ".mcmeta";
+                    if (pack.hasFile(metaPath)) {
+                        try (InputStream stream = pack.getResourceAsStream(metaPath)){
+                            coordinate.initMetadata(stream);
+                        } catch (Exception e) {
+                            e.printStackTrace();
+                        }
+                    }
+                }
+
+            }
+            if (image == null || image == Textures.missingTexture){
+                System.out.println(coordinate.sourceImage + " could not be found!");
+                if (defaultTexture != null){
+                    image = Textures.readImage(mc.texturePackList.getResourceAsStream(defaultTexture));
+                }
+                if (image == null) image = Textures.missingTexture; // If this ever happens I'll be very sad
+            }
+            coordinate.setImage(image);
+            return coordinate;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
similarity index 63%
rename from src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java
rename to src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index 6557c41c8..f8029c1ca 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/IconCoordinate.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -1,17 +1,22 @@
-package net.minecraft.client.render.stitcher;
+package net.minecraft.client.render.texture.stitcher;
 
+import net.minecraft.client.render.texture.meta.TextureMetaHandler;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.awt.*;
 import java.awt.image.BufferedImage;
+import java.io.InputStream;
 
 public class IconCoordinate implements Comparable<IconCoordinate> {
     public int iconX;
     public int iconY;
     public int width;
     public int height;
+    private boolean pendingDimensions;
     protected final String sourceImage;
+    protected final TextureMetaHandler metaHandler = new TextureMetaHandler();
     public final NamespaceID namespaceId;
     public final AtlasStitcher parentAtlas;
     private BufferedImage _imageStorage;
@@ -21,14 +26,27 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         this.sourceImage = sourceImage;
     }
     protected void setImage(BufferedImage image){
+        this.pendingDimensions = true;
         this._imageStorage = image;
     }
+
+    // This will only ever return the actual image when used during a very narrow period of time
+    // Its very much for use with the atlas stitching process and dynamic textures
+    public BufferedImage getImageStorage() {
+        return _imageStorage;
+    }
+
     protected void discardImage(){
         this._imageStorage = null;
     }
+
+    public boolean needsDimensions() {
+        return pendingDimensions;
+    }
     public void setDimension(int width, int height){
         this.width = width;
         this.height = height;
+        pendingDimensions = false;
     }
     public void setPosition(int x, int y){
         this.iconX = x;
@@ -62,10 +80,34 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         return String.format("W:%d, H:%d, X:%d, Y:%d | ID:%s, Source:%s", width, height, iconX, iconY, namespaceId, sourceImage);
     }
 
+    public String getImageSource() {
+        return sourceImage;
+    }
+
     @Override
     public int compareTo(@NotNull IconCoordinate o) {
         int res = o.height - height;
         if (res != 0) return res;
         return namespaceId.compareTo(o.namespaceId);
     }
+
+    protected void resetMetadata() {
+        metaHandler.reset();
+    }
+
+    protected void initMetadata(InputStream stream) {
+        metaHandler.loadFromStream(stream);
+    }
+
+    public boolean hasMeta(String key) {
+        return metaHandler.has(key);
+    }
+
+    public @Nullable <T> T getMeta(String key, Class<T> aClass) {
+        return metaHandler.get(key, aClass);
+    }
+
+    public <T> T getOrDefaultMeta(String key, T metaDefault, Class<T> aClass) {
+        return metaHandler.getOrDefault(key, metaDefault, aClass);
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java b/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
similarity index 82%
rename from src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
rename to src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 011fb256b..070eee5f0 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -1,9 +1,11 @@
-package net.minecraft.client.render.stitcher;
+package net.minecraft.client.render.texture.stitcher;
 
+
+
+import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 
-import java.io.File;
 import java.io.IOException;
 import java.net.URI;
 import java.net.URISyntaxException;
@@ -13,30 +15,34 @@ import java.nio.file.Files;
 import java.nio.file.Path;
 import java.nio.file.Paths;
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.Collections;
-import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Objects;
-import java.util.jar.JarEntry;
-import java.util.jar.JarFile;
 import java.util.stream.Stream;
 
 public class TextureRegistry {
     public static HashMap<String, AtlasStitcher> stitcherMap = new HashMap<>();
     @SuppressWarnings("unused")
-    public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", true, "/assets/minecraft/textures/block/texture_missing.png"));
+    public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", false, true, "/assets/minecraft/textures/block/texture_missing.png"));
+    @SuppressWarnings("unused")
+    public static AtlasStitcher itemAtlas =  register("item", new AtlasStitcher("textures/item", false, true, "/assets/minecraft/textures/item/texture_missing.png"));
+    @SuppressWarnings("unused")
+    public static AtlasStitcher particleAtlas = register("particle", new AtlasStitcher("textures/particle", false, true, null));
     @SuppressWarnings("unused")
-    public static AtlasStitcher itemAtlas =  register("item", new AtlasStitcher("textures/item", true, "/assets/minecraft/textures/item/texture_missing.png"));
+    public static AtlasStitcher artAtlas = register("art", new AtlasStitcher("textures/art", false, true, null));
     @SuppressWarnings("unused")
-    public static AtlasStitcher particleAtlas = register("particle", new AtlasStitcher("textures/particle", false, null));
+    public static AtlasStitcher guiSpriteAtlas = register("gui", new AtlasStitcher("textures/gui/sprites", true, false, null));
     @SuppressWarnings("unused")
-    public static AtlasStitcher artAtlas = register("art", new AtlasStitcher("textures/art", false, null));
+    public static AtlasStitcher signAtlas = register("sign", new AtlasStitcher("textures/gui/sign", false, false, null));
 
     public static @NotNull IconCoordinate getTexture(@NotNull String key){
-        return getTexture(new NamespaceID(key));
+        try {
+            return getTexture(new NamespaceID(key));
+        } catch (HardIllegalArgumentException e) {
+            throw new RuntimeException(e);
+        }
     }
     public static @NotNull IconCoordinate getTexture(@NotNull NamespaceID id){
         String[] split2 = id.value.split("/");
@@ -51,7 +57,11 @@ public class TextureRegistry {
         return atlas.getTexture(new NamespaceID(id.namespace, target.toString()));
     }
     public static boolean hasTexture(@NotNull String key) {
-        return hasTexture(new NamespaceID(key));
+        try {
+            return hasTexture(new NamespaceID(key));
+        } catch (HardIllegalArgumentException e) {
+            throw new RuntimeException(e);
+        }
     }
     public static boolean hasTexture(@NotNull NamespaceID id){
         String[] split2 = id.value.split("/");
@@ -89,7 +99,7 @@ public class TextureRegistry {
 //        System.out.println("Printing " + path);
         for (String s : files) {
 //            System.out.println(s);
-            atlas.getTexture(new NamespaceID(namespace, s.replace(".png", "")));
+            atlas.getTexture(new NamespaceID(namespace, s.replace(".png", "").replace("//", "/")));
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index 1a3774c65..6fe225e61 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -14,23 +14,22 @@ import java.util.List;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipFile;
 
-import org.lwjgl.opengl.GL11;
-
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.BufferedTexture;
 import net.minecraft.client.render.texturepack.Manifest.ManifestException;
 
 import javax.imageio.ImageIO;
 
 public class TexturePackCustom extends TexturePack
 {
-	private int thumbnailImage;
+	private BufferedTexture thumbnailImage;
 	private BufferedImage thumbnailBuffer;
-	private final File file;
+	public final File file;
 	private ZipFile zipFile;
 
     public TexturePackCustom(File file)
     {
-        thumbnailImage = -1;
+        thumbnailImage = null;
         fileName = file.getName();
         this.file = file;
     }
@@ -173,7 +172,8 @@ public class TexturePackCustom extends TexturePack
     {
         if(thumbnailBuffer != null)
         {
-            minecraft.renderEngine.deleteTexture(thumbnailImage);
+			thumbnailImage.delete();
+			thumbnailImage = null;
         }
         closeTexturePackFile();
     }
@@ -181,16 +181,16 @@ public class TexturePackCustom extends TexturePack
     @Override
 	public void bindThumbnailTexture(Minecraft minecraft)
     {
-        if(thumbnailBuffer != null && thumbnailImage < 0)
+        if(thumbnailBuffer != null && thumbnailImage == null)
         {
-            thumbnailImage = minecraft.renderEngine.allocateAndSetupTexture(thumbnailBuffer);
+            thumbnailImage = minecraft.renderEngine.loadBufferedTexture(thumbnailBuffer);
         }
         if(thumbnailBuffer != null)
         {
             minecraft.renderEngine.bindTexture(thumbnailImage);
         } else
         {
-            GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/assets/minecraft/textures/gui/unknown_pack.png"));
+			minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
